package org.convey;

import java.awt.*;
import java.awt.geom.*;

/**
 * @author Andy Ames
 * @version 0.1
 */
public class EllipseGraphic extends RectangularGraphic {

  public EllipseGraphic(GraphicPanel graphicPanel) {
		super(graphicPanel);
  }

	/**
	 * Paints the Graphic object onto the Graphics2D object.
	 */
	public void paint(Graphics2D g2d) {
		if(g2d != null) {
			g2d.setStroke(new BasicStroke());
			g2d.setColor(Color.black);

			g2d.drawOval(super.rectangle.x, super.rectangle.y,
								   super.rectangle.width, super.rectangle.height);
		}
	}

	public boolean contains(Point pt) {
		if(super.contains(pt))
			return true;

		BasicStroke hotspot = new BasicStroke(6);

		Ellipse2D ellipse = new Ellipse2D.Float(super.rectangle.x,
																					  super.rectangle.y,
											  								    super.rectangle.width,
																						super.rectangle.height);
	  if(hotspot.createStrokedShape(ellipse).contains(pt))
			return true;

		return false;
	}

}
