package org.convey;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.ListIterator;

/**
 * @author Ed Braunhut
 * @version 0.1
 */
public class PolygonBuilder extends PolylineBuilder {

	public PolygonBuilder() {}

	public PolygonBuilder(GraphicPanel graphicPanel) {
		super(graphicPanel);
	}
	/**
	 *	paint the rectangle bounding current and previous rubberband line
	 *	this will also call the other ShapeGraphics repaint method to
	 *  repaint the portions contained in bounding rectangle
	 *
	 */

	public void paint(Graphics2D g2d) {

		if (this.shape != null) {
			float[] dash = {6,6};
			g2d.setStroke(new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0.0f, dash, 0.0f));
			g2d.setColor(Color.black);
			g2d.drawLine(this.currPt.x, this.currPt.y, this.prevPt.x, this.prevPt.y);
			g2d.drawLine(this.currPt.x, this.currPt.y, this.startPt.x, this.startPt.y);
		}
	}
	public void mouseClicked(MouseEvent e) {
		super.mouseClicked(e);
	}
	public void mouseMoved(MouseEvent e) {
		super.mouseMoved(e);
	}
	/**
	 * Invoked when completing the Shape
	 */
	public void finishShape(Point startPt) {
		int[] coords = {currPt.x, currPt.y, 0, 0, 0, 0};
		shape.addCoords(shape.coordCount(),ShapeGraphic.SEG_LINETO, coords);
		super.graphicPanel.repaint();
		int[] coordsEnd = {startPt.x, startPt.y, 0, 0, 0, 0};
		shape.addCoords(shape.coordCount(),ShapeGraphic.SEG_CLOSE, coordsEnd);
		//this.currPt = this.startPt;
		super.graphicPanel.repaint();
		clickCount = 0;
		shape = null;
	}
}

