package org.convey;

import java.awt.*;
import java.awt.geom.*;

/**
 * @author Andy Ames
 * @version 0.1
 */
public class RectangleGraphic extends RectangularGraphic {

  public RectangleGraphic(GraphicPanel graphicPanel) {
		super(graphicPanel);
  }

	/**
	 * Paints the Graphic object onto the Graphics2D object.
	 */
	public void paint(Graphics2D g2d) {
		if(g2d != null) {
			g2d.setStroke(new BasicStroke());
			g2d.setColor(Color.black);

			g2d.draw(super.rectangle);
		}
	}

	public boolean contains(Point pt) {
		if(super.contains(pt))
			return true;

		BasicStroke hotspot = new BasicStroke(6);

	  if(hotspot.createStrokedShape(super.rectangle).contains(pt))
			return true;

		return false;
	}

}
