package org.convey;

import javax.swing.event.*;

import java.awt.event.*;

import java.awt.*;

/**
 * @author Andy Ames
 * @version 0.1
 */
public abstract class AbstractSelectionBuilder extends AbstractBuilder implements SelectionBuilder {

	protected Graphic selected;

	protected AbstractSelectionBuilder() {}

	public AbstractSelectionBuilder(GraphicPanel graphicPanel) {
		this(graphicPanel, null);
	}

	public AbstractSelectionBuilder(GraphicPanel graphicPanel, Graphic selected) {

		super(graphicPanel);
		this.selected = selected;
	}

	public void paint(Graphics2D g2d) {
		if(this.selected != null)
			this.selected.paintSelection(g2d);
	}

	public Graphic getSelected() {
		return this.selected;
	}

	public void setSelected(Graphic selected) {
		if(selected != this.selected) {
			if(this.selected != null)
				this.selected.setSelected(false);

			this.selected = selected;

			if(this.selected != null)
				this.selected.setSelected(true);
		}
	}

}
