/**
 * PointRemover.java
 *
 * @author Ed Braunhut
 * @version 0.1
 */

package org.convey;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import javax.swing.JTextArea;



public class CtrlPointRemoveBuilder extends ControlPointSelectionBuilder {
	
	protected boolean allowDrag = true;
	
	public CtrlPointRemoveBuilder() {}
	
	public CtrlPointRemoveBuilder(GraphicPanel graphicPanel) {
		super(graphicPanel);
	}
	
	/**
	 * Invoked when the mouse has been clicked on a component.
	 */
	public void mousePressed(MouseEvent e) {
		super.mousePressed(e);
		if (super.segmentIndex != -1) {//we clicked on a cntrl point
			ShapeGraphic graphic = (ShapeGraphic)super.selected;
			int type;
			int[] coords = new int[6];
			int[] coords2 = new int[6];
			type = graphic.getCoords(super.segmentIndex, coords);
			if (super.segmentIndex == 0  && type == ShapeGraphic.SEG_MOVETO &&
			    	graphic.coordCount() == 2 &&
					graphic.getCoords(1,coords2) == ShapeGraphic.SEG_LINETO) {
				coords[0] = coords2[0];
				coords[1] = coords2[1];
				graphic.setCoords(0,ShapeGraphic.SEG_MOVETO, coords);
				graphic.setCoords(1,ShapeGraphic.SEG_POINT, coords2);
			} else if (super.segmentIndex == 1  && type == ShapeGraphic.SEG_LINETO &&
			    		graphic.coordCount() == 2) {
				graphic.setCoords(1,ShapeGraphic.SEG_POINT, coords2);
			} else if (super.segmentIndex == 0  && type == ShapeGraphic.SEG_MOVETO &&
			    		graphic.coordCount() > 2 &&
						graphic.getCoords(1,coords2) == ShapeGraphic.SEG_LINETO) {
				graphic.setCoords(1,ShapeGraphic.SEG_MOVETO, coords2);
				graphic.removeCoords(0,coords);
			} else if (super.segmentIndex == graphic.coordCount() - 1  &&
					   type == ShapeGraphic.SEG_LINETO &&
			    	   graphic.coordCount() > 2 ) {
				graphic.removeCoords(graphic.coordCount() - 1, coords);
			} else if (super.segmentIndex > 0 &&
					     super.segmentIndex < graphic.coordCount() - 1 &&
					     type == ShapeGraphic.SEG_LINETO &&
						 graphic.getCoords(super.segmentIndex + 1, coords2) == ShapeGraphic.SEG_LINETO) {
				coords[0] = coords2[0];
				coords[1] = coords2[1];
				graphic.setCoords(super.segmentIndex, ShapeGraphic.SEG_LINETO, coords);
				graphic.removeCoords(super.segmentIndex + 1, coords2);
			} else if (super.segmentIndex > 0 &&
					     super.segmentIndex < graphic.coordCount() - 1 &&
					     graphic.coordCount() ==  4 &&
					     graphic.getCoords(1, coords2) == ShapeGraphic.SEG_LINETO &&
					     type == ShapeGraphic.SEG_LINETO &&
						 graphic.getCoords(graphic.coordCount() - 1, coords2) == ShapeGraphic.SEG_CLOSE) {
				graphic.removeCoords(graphic.coordCount() - 1, coords);
				graphic.removeCoords(super.segmentIndex,  coords);
			}else if (super.segmentIndex > 0 &&
					     super.segmentIndex < graphic.coordCount() - 1 &&
					     type == ShapeGraphic.SEG_LINETO &&
						 graphic.getCoords(super.segmentIndex + 1, coords2) == ShapeGraphic.SEG_CLOSE) {
				graphic.removeCoords(super.segmentIndex,  coords);
			}
			super.graphicPanel.repaint();
			super.segmentIndex = -1;
			this.allowDrag = false;
		}
	}

	public void mouseDragged(MouseEvent e) {
		if (this.allowDrag)
			super.mouseDragged(e);
	}
		
	public void mouseReleased(MouseEvent e) {
		this.allowDrag = true;
		super.mouseReleased(e);
	}
		//determine whether click was on a shape or not (hotspot)
		//if not, do nothing
		//if it is, determine what the graphic type is.
		// switch
		//	case: 	Cubic curve  shape becomes 2 quad curves
		//
		//  case:   Quad curve  shape becomes cubic curve
		//
		//	case:	Line  shape becomes quad curve
		//



}

