package org.convey;

import java.awt.*;

/**
 * EllipseBuilder.java
 *
 * @author Ed Braunhut
 * @version 0.1
 */
public class EllipseBuilder extends RectangleBuilder {

	public EllipseBuilder(GraphicPanel graphicPanel) {
		super(graphicPanel);
	}

	protected void finish() {
		EllipseGraphic ellipse = new EllipseGraphic(super.graphicPanel);
		ellipse.setRectangle(new Rectangle(Math.min(this.startPt.x, this.endPt.x),
										Math.min(this.startPt.y, this.endPt.y),
										Math.abs(this.endPt.x - this.startPt.x),
										Math.abs(this.endPt.y - this.startPt.y)));
		super.graphicPanel.graphics.add(ellipse);
	}

}

