package org.convey;

import java.awt.*;
import java.awt.geom.*;

/**
 * @author Andy Ames
 * @version 0.1
 */
public abstract class RectangularGraphic extends Graphic {

	protected Rectangle rectangle = new Rectangle();

	public RectangularGraphic(GraphicPanel graphicPanel) {
		super(graphicPanel);
	}

	public Rectangle getRectangle() {
		return new Rectangle(this.rectangle);
	}

	public void setRectangle(Rectangle rectangle) {
		this.rectangle.setRect(rectangle);
	}

	public void paintSelection(Graphics2D g2d) {
		if(g2d != null) {
			float[] dash = { 6, 6 };
			BasicStroke selStroke = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0.0f, dash, 0.0f);
			g2d.setStroke(selStroke);
			g2d.setColor(Color.white);

			g2d.draw(this.rectangle);

			selStroke = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0.0f, dash, 6.0f);
			g2d.setStroke(selStroke);
			g2d.setColor(Color.gray);

			g2d.draw(this.rectangle);
		}
	}

	public boolean contains(Point pt) {
		if(super.selected) {
			BasicStroke hotspot = new BasicStroke(6);
	    if(hotspot.createStrokedShape(this.rectangle).contains(pt))
		  	return true;
		}

		return false;
	}

	public void translate(int tx, int ty) {
		this.rectangle.translate(tx, ty);
	}

}
